//
// File: CBarCode.cc
// Created by: User <Email>
// Created on: Wed Mar  2 11:45:37 2005
//

#include "CBarCode.h"


CBarCode::CBarCode() : CImage()
{
	
}


CBarCode::~CBarCode()
{
	
}

void CBarCode::Process(char *name)
{
	ReadPPM(name);
	ConvertToGray();

	ComputeEdge();
	WriteGrayPPM("result.pgm");
}

void CBarCode::ComputeEdge()
{
	int Bound=230;
	int x,y;
	int N=8,K=1,L=5;
	
	miny=height*K/N;
	maxy=height*L/N;
	int nSize=maxy-miny;
	int *f=new int[nSize];

	int sum_yi2=0,sum_yi=0,sum_yi_fi=0,sum_fi=0;
	int fi;
	for (y=miny;y<maxy;y++)
	{
		x=0;
		while (gray[IDX(x,y)]>=Bound&&x<width) x++;
		f[y-miny]=x;
		fi=f[y-miny];
		sum_yi2+=y*y;
		sum_yi+=y;
		sum_yi_fi+=y*fi;
		sum_fi+=fi;
	}
	int A11,A12,A21,A22,B1,B2;

	A11 = sum_yi2; A12 = sum_yi; B1=sum_yi_fi;
	A21 = sum_yi;  A22 = nSize; B2=sum_fi;
	
	int D=A11*A22-A12*A21;
	int a,b;
	a=(B1*A22-A12*B2);	// /D
	b=(A11*B2-B1*A21);	// /D
	
	printf ("%d %d %d\n",a,b,D);

	/*		D*x= a*y+b 
			D*x-a*y-b=0
			n=(D,-a) => n=(D/sqrt(a*a+D*D),-a/sqrt(a*a+D*D) )
			(sx,sy)=(nx,ny);
	*/
//	REAL norm=sqrt(a*a+1);
	int sx,sy;
//	sx=1/norm;
//	sy=-a/norm;
	sx=D;
	sy=-a;
	int blnGo;
	int t=0;
	do
	{
		blnGo=0;
		x=(int) (sx*t/D);
		y=(int) (sy*t/D+height/2);
		if (x>=0&&x<width&&y>=0&&y<height) 
		{
			blnGo=1;
			gray[IDX(x,y)]=255;
		}
		t++;
	} while (blnGo);
	
	for (y=miny;y<maxy;y++)
	{
		fi=a*y+b;
		x=(int)(fi/D);
		if (x>=0&&x<width) gray[IDX(x,y)]=0;
		if (x-1>=0&&x-1<width) gray[IDX(x-1,y)]=0;
	}

	
//	for (x=0;x<width;x++) gray[IDX(x,10)]=0;
//	for (x=0;x<width;x++) R[IDX(x,10)]=0;
}
