//
// File: CImage.h
// Created by: User <Email>
// Created on: Wed Mar  2 11:18:31 2005
//

#ifndef _CIMAGE_H_
#define _CIMAGE_H_

#include <stdio.h>
#include <math.h>

#define IDX(x,y)  ((x)+(y)*width)

class CImage
{
	public:
		CImage();
		 ~CImage();
	
		void ReadPPM(char *name);
		void WriteGrayPPM(char *name);
		void WritePPM(char *name);
		void ConvertToGray();

		int GetWidth();
		int GetHeight();
		int GetMaxcolor();

	protected:
		int width;
	    int height;
		int maxcolor;
	    int *gray;
	    int *R;
	    int *G;
	    int *B;

		void Delete();
	
};


#endif	//_CIMAGE_H_
